
#ifndef __DAMSEL_DEBUG_H
#define __DAMSEL_DEBUG_H

#ifdef NDEBUG
#define assert_is_damsel_type(x) ;
#else
#define assert_is_damsel_type(x) { assert(inner_assert_is_damsel_type(x)); }
#endif

#define assert_is_initialized() { assert(globals_initialized == 1); }

int inner_assert_is_damsel_type(damsel_data_type t);

#define assert_valid_model_id(model_id) { assert(model_id != NULL && (\
  ((damsel_model_internal *)model_id)->store.type == DAMSEL_STORETYPE_MEMORY)); }

#define assert_valid_store_id(store_id) { assert(store_id != NULL && (\
  ((damsel_store_internal *)store_id)->type == DAMSEL_STORETYPE_MEMORY || \
  ((damsel_store_internal *)store_id)->type == DAMSEL_STORETYPE_HDF5)); }

/*
#define assert_valid_handle_container_id(hc) { assert(hc != NULL && (\
((damsel_container_internal *)hc)->type == DAMSEL_HANDLE_CONTAINER_TYPE_SEQUENCE || \
((damsel_container_internal *)hc)->type == DAMSEL_HANDLE_CONTAINER_TYPE_VECTOR  || \
((damsel_container_internal *)hc)->type == DAMSEL_HANDLE_CONTAINER_TYPE_TREE \
   )); assert_valid_store_id( ((damsel_container_internal *)hc)->model) ; }
*/

// at the moment, we can have containers around invalid model IDs, because the model
// may have been closed already. so we can't assert that the model is valid (as in the
// above commented out code).
// Later on, I hope to fix this.
#define assert_valid_handle_container_id(hc) { assert(hc != NULL && (\
((damsel_container_internal *)hc)->type == DAMSEL_HANDLE_CONTAINER_TYPE_SEQUENCE || \
((damsel_container_internal *)hc)->type == DAMSEL_HANDLE_CONTAINER_TYPE_VECTOR  || \
((damsel_container_internal *)hc)->type == DAMSEL_HANDLE_CONTAINER_TYPE_TREE \
   ) && (\
((damsel_container_internal *)hc)->written == DAMSEL_WRITTEN || \
((damsel_container_internal *)hc)->written == DAMSEL_UNWRITTEN \
)); }

#define assert_dmsl_ok(r) assert(r.id == 0);

#define assert_dmsl_ok(r) assert(r.id == 0);

/*
#define DAMSEL_STORETYPE_MEMORY 524
#define DAMSEL_STORETYPE_FILE 835
#define DAMSEL_STORETYPE_HDF5 1212
*/

// how do I know a tag handle is valid?
// its always within the context of a particular store...
// so I'm going to need to pass in a store value too
#define assert_valid_tag_handle(tag_handle, store) { assert(inner_assert_valid_tag_handle(tag_handle, store)); }

#define assert_valid_tag_definition_structure(tagdef) {  assert(tagdef != NULL); assert( ((damsel_tag_internal *)tagdef)->magic == DAMSEL_TAG_MAGIC); assert(((damsel_tag_internal *)tagdef)->written == DAMSEL_UNWRITTEN || ((damsel_tag_internal *)tagdef)->written == DAMSEL_WRITTEN); }

#define assert_valid_rank(r, max) { assert(r<(max)); assert(r>=0); }

#endif
