
#include <assert.h>

#include "damsel.h"
#include "damsel-internal.h"
#include <stdio.h>

void noop(void *m) {
  // nothing - don't need to free linked list members in this test
}

int main() {
  printf("linked list tests\n");

  char *foo = "foo";

  linkedlist *l1 = NULL;
  assert(linkedlist_length(l1) == 0);

  linkedlist *l2 = NULL;
  linkedlist_append(&l2, foo);
  linkedlist_append(&l2, foo);
  linkedlist_append(&l2, foo);
  assert(linkedlist_length(l2) == 3);

  linkedlist *l3 = NULL;
  linkedlist_prepend(&l3, foo);
  linkedlist_prepend(&l3, foo);
  assert(linkedlist_length(l3) == 2);

  linkedlist_free(l1, noop);
  linkedlist_free(l2, noop);
  linkedlist_free(l3, noop);

  return 0;
}
