#!/bin/bash

rm -f test-nwrite test-parallel-read test-parallel-write test-flash-write-parallel test-nconnectivitywrite
make test-nwrite test-parallel-read test-parallel-write test-flash-write-parallel test-nconnectivitywrite

# Writing to 2 subfiles while varying number of ranks
for proc in 2 4 8 16
do
    rm -f output/*
    echo "running test-nwrite (using $proc ranks)..."
    mpiexec -n $proc ./test-nwrite
done

# Reading/Writing is done with 4 ranks
rm -f output/*
echo "running test-nwrite (using 4 ranks)..."
mpiexec -n 4 ./test-nwrite
echo "running test-parallel-read output/nFilewrite.h5 (using 4 ranks)..."
mpiexec -n 4 ./test-parallel-read output/nFilewrite.h5

# testing for writing to subfiles using test-parallel-write
rm -f output/*
echo "running test-parallel-write (using 4 ranks)..."
mpiexec -n 4 ./test-parallel-write

# testing for writing to subfiles using test-flash-write-parallel
# note: it works with 4 MPI processes only
rm -f output/*
echo "running test-flash-write-parallel (using 4 ranks)..."
mpiexec -n 4 ./test-flash-write-parallel

# testing subfiling using parallel write connectivity case
# note: it works with 2 MPI processes only
rm -f output/*
echo "running test-nconnectivitywrite (using 2 ranks)..."
mpiexec -n 2 ./test-nconnectivitywrite
