/* this test is expected to fail: it initializes MPI with the wrong thread
 * level.  The Damsel library should catch this and return an error (or assert)
 */ 

#include <assert.h>
#include <stdio.h>

#include "mpi.h"
#include "damsel.h"


int main(int argc, char ** argv) 
{
    MPI_Init(&argc, &argv);
    damsel_library lib;
    damsel_err_t err = DMSLlib_init(&lib);
#ifdef DAMSEL_SINGLETHREAD
    assert(lib!= DAMSEL_LIBRARY_INVALID);
    DMSLlib_finalize(lib);
    MPI_Finalize();
    return 0;
#else
    // we're in multithreaded mode
    if(lib == DAMSEL_LIBRARY_INVALID) {
      printf("We got an invalid library handle, as expected. Test passes.\n");
      return 0;
    } else {
      printf("Library handle was not DAMSEL_LIBRARY_INVALID but it should have been. Test fails.\n");
      return 1;
    }
#endif
}
